Index: trunk/BNC/qwt/qwt_plot_zoomer.h
===================================================================
--- trunk/BNC/qwt/qwt_plot_zoomer.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_zoomer.h	(revision 9383)
@@ -23,12 +23,12 @@
   the coordinates of the current mouse position.
 
-  Zooming can be repeated as often as possible, limited only by 
+  Zooming can be repeated as often as possible, limited only by
   maxStackDepth() or minZoomSize().  Each rectangle is pushed on a stack.
 
-  The default setting how to select rectangles is 
+  The default setting how to select rectangles is
   a QwtPickerDragRectMachine with the following bindings:
 
   - QwtEventPattern::MouseSelect1\n
-    The first point of the zoom rectangle is selected by a mouse press, 
+    The first point of the zoom rectangle is selected by a mouse press,
     the second point from the position, where the mouse is released.
 
@@ -45,5 +45,5 @@
   - QwtEventPattern::MouseSelect3, QwtEventPattern::KeyUndo\n
     Zoom out one position on the zoom stack
-    
+
   - QwtEventPattern::MouseSelect6, QwtEventPattern::KeyRedo\n
     Zoom in one position on the zoom stack
@@ -53,7 +53,7 @@
 
   The setKeyPattern() and setMousePattern() functions can be used
-  to configure the zoomer actions. The following example 
-  shows, how to configure the 'I' and 'O' keys for zooming in and out 
-  one position on the zoom stack. The "Home" key is used to 
+  to configure the zoomer actions. The following example
+  shows, how to configure the 'I' and 'O' keys for zooming in and out
+  one position on the zoom stack. The "Home" key is used to
   "unzoom" the plot.
 
@@ -103,9 +103,9 @@
 
 public Q_SLOTS:
-    void moveBy( double x, double y );
+    void moveBy( double dx, double dy );
     virtual void moveTo( const QPointF & );
 
     virtual void zoom( const QRectF & );
-    virtual void zoom( int up );
+    virtual void zoom( int offset );
 
 Q_SIGNALS:
Index: trunk/BNC/qwt/qwt_point_data.h
===================================================================
--- trunk/BNC/qwt/qwt_point_data.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_point_data.h	(revision 9383)
@@ -26,5 +26,5 @@
 
     virtual size_t size() const;
-    virtual QPointF sample( size_t i ) const;
+    virtual QPointF sample( size_t index ) const;
 
     const QVector<double> &xData() const;
@@ -46,5 +46,5 @@
     virtual QRectF boundingRect() const;
     virtual size_t size() const;
-    virtual QPointF sample( size_t i ) const;
+    virtual QPointF sample( size_t index ) const;
 
     const double *xData() const;
@@ -123,5 +123,5 @@
 
     virtual QRectF boundingRect() const;
-    virtual QPointF sample( size_t i ) const;
+    virtual QPointF sample( size_t index ) const;
 
     /*!
Index: trunk/BNC/qwt/qwt_point_mapper.cpp
===================================================================
--- trunk/BNC/qwt/qwt_point_mapper.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_point_mapper.cpp	(revision 9383)
@@ -23,5 +23,5 @@
 
 #if !defined(QT_NO_QFUTURE)
-#define QWT_USE_THREADS 0
+#define QWT_USE_THREADS 1
 #endif
 
@@ -43,5 +43,5 @@
 static void qwtRenderDots(
     const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-    const QwtDotsCommand command, const QPoint &pos, QImage *image ) 
+    const QwtDotsCommand command, const QPoint &pos, QImage *image )
 {
     const QRgb rgb = command.rgb;
@@ -95,5 +95,5 @@
 
 struct QwtNoRoundF
-{   
+{
     inline double operator()( double value )
     {
@@ -106,8 +106,8 @@
 
 template<class Polygon, class Point, class Round>
-static inline Polygon qwtToPoints( 
+static inline Polygon qwtToPoints(
     const QRectF &boundingRect,
     const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-    const QwtSeriesData<QPointF> *series, 
+    const QwtSeriesData<QPointF> *series,
     int from, int to, Round round )
 {
@@ -169,5 +169,5 @@
     int from, int to )
 {
-    return qwtToPoints<QPolygon, QPoint>( 
+    return qwtToPoints<QPolygon, QPoint>(
         boundingRect, xMap, yMap, series, from, to, QwtRoundI() );
 }
@@ -180,5 +180,5 @@
     int from, int to, Round round )
 {
-    return qwtToPoints<QPolygonF, QPointF>( 
+    return qwtToPoints<QPolygonF, QPointF>(
         boundingRect, xMap, yMap, series, from, to, round );
 }
@@ -188,7 +188,7 @@
 
 template<class Polygon, class Point, class Round>
-static inline Polygon qwtToPolylineFiltered( 
-    const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-    const QwtSeriesData<QPointF> *series, 
+static inline Polygon qwtToPolylineFiltered(
+    const QwtScaleMap &xMap, const QwtScaleMap &yMap,
+    const QwtSeriesData<QPointF> *series,
     int from, int to, Round round )
 {
@@ -239,5 +239,5 @@
     return qwtToPolylineFiltered<QPolygonF, QPointF>(
         xMap, yMap, series, from, to, round );
-} 
+}
 
 template<class Polygon, class Point>
@@ -283,5 +283,5 @@
     return qwtToPointsFiltered<QPolygon, QPoint>(
         boundingRect, xMap, yMap, series, from, to );
-} 
+}
 
 static inline QPolygonF qwtToPointsFilteredF(
@@ -390,5 +390,5 @@
 
   When the WeedOutPoints flag is enabled consecutive points,
-  that are mapped to the same position will be one point. 
+  that are mapped to the same position will be one point.
 
   When RoundPoints is set all points are rounded to integers
@@ -414,10 +414,10 @@
         if ( d_data->flags & RoundPoints )
         {
-            polyline = qwtToPolylineFilteredF( 
+            polyline = qwtToPolylineFilteredF(
                 xMap, yMap, series, from, to, QwtRoundF() );
         }
         else
         {
-            polyline = qwtToPolylineFilteredF( 
+            polyline = qwtToPolylineFilteredF(
                 xMap, yMap, series, from, to, QwtNoRoundF() );
         }
@@ -427,10 +427,10 @@
         if ( d_data->flags & RoundPoints )
         {
-            polyline = qwtToPointsF( qwtInvalidRect, 
+            polyline = qwtToPointsF( qwtInvalidRect,
                 xMap, yMap, series, from, to, QwtRoundF() );
         }
         else
         {
-            polyline = qwtToPointsF( qwtInvalidRect, 
+            polyline = qwtToPointsF( qwtInvalidRect,
                 xMap, yMap, series, from, to, QwtNoRoundF() );
         }
@@ -444,5 +444,5 @@
 
   When the WeedOutPoints flag is enabled consecutive points,
-  that are mapped to the same position will be one point. 
+  that are mapped to the same position will be one point.
 
   \param xMap x map
@@ -462,10 +462,10 @@
     if ( d_data->flags & WeedOutPoints )
     {
-        polyline = qwtToPolylineFilteredI( 
+        polyline = qwtToPolylineFilteredI(
             xMap, yMap, series, from, to );
     }
     else
     {
-        polyline = qwtToPointsI( 
+        polyline = qwtToPointsI(
             qwtInvalidRect, xMap, yMap, series, from, to );
     }
@@ -478,14 +478,14 @@
 
   - WeedOutPoints & RoundPoints & boundingRect().isValid()
-    All points that are mapped to the same position 
+    All points that are mapped to the same position
     will be one point. Points outside of the bounding
     rectangle are ignored.
- 
+
   - WeedOutPoints & RoundPoints & !boundingRect().isValid()
-    All consecutive points that are mapped to the same position 
+    All consecutive points that are mapped to the same position
     will one point
 
-  - WeedOutPoints & !RoundPoints 
-    All consecutive points that are mapped to the same position 
+  - WeedOutPoints & !RoundPoints
+    All consecutive points that are mapped to the same position
     will one point
 
@@ -516,15 +516,15 @@
         {
             if ( d_data->boundingRect.isValid() )
-            {   
+            {
                 points = qwtToPointsFilteredF( d_data->boundingRect,
                     xMap, yMap, series, from, to );
             }
             else
-            {   
+            {
                 // without a bounding rectangle all we can
                 // do is to filter out duplicates of
                 // consecutive points
 
-                points = qwtToPolylineFilteredF( 
+                points = qwtToPolylineFilteredF(
                     xMap, yMap, series, from, to, QwtRoundF() );
             }
@@ -535,5 +535,5 @@
             // qwtToPointsFilteredF
 
-            points = qwtToPolylineFilteredF( 
+            points = qwtToPolylineFilteredF(
                 xMap, yMap, series, from, to, QwtNoRoundF() );
         }
@@ -560,10 +560,10 @@
 
   - WeedOutPoints & boundingRect().isValid()
-    All points that are mapped to the same position 
+    All points that are mapped to the same position
     will be one point. Points outside of the bounding
     rectangle are ignored.
- 
+
   - WeedOutPoints & !boundingRect().isValid()
-    All consecutive points that are mapped to the same position 
+    All consecutive points that are mapped to the same position
     will one point
 
@@ -597,5 +597,5 @@
             // we can do is to filter out consecutive duplicates
 
-            points = qwtToPolylineFilteredI( 
+            points = qwtToPolylineFilteredI(
                 xMap, yMap, series, from, to );
         }
@@ -603,5 +603,5 @@
     else
     {
-        points = qwtToPointsI( 
+        points = qwtToPointsI(
             d_data->boundingRect, xMap, yMap, series, from, to );
     }
@@ -631,5 +631,5 @@
 QImage QwtPointMapper::toImage(
     const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-    const QwtSeriesData<QPointF> *series, int from, int to, 
+    const QwtSeriesData<QPointF> *series, int from, int to,
     const QPen &pen, bool antialiased, uint numThreads ) const
 {
@@ -681,5 +681,5 @@
                 command.to = index0 + numPoints - 1;
 
-                futures += QtConcurrent::run( &qwtRenderDots, 
+                futures += QtConcurrent::run( &qwtRenderDots,
                     xMap, yMap, command, pos, &image );
             }
Index: trunk/BNC/qwt/qwt_point_polar.h
===================================================================
--- trunk/BNC/qwt/qwt_point_polar.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_point_polar.h	(revision 9383)
@@ -31,5 +31,4 @@
     QwtPointPolar();
     QwtPointPolar( double azimuth, double radius );
-    QwtPointPolar( const QwtPointPolar & );
     QwtPointPolar( const QPointF & );
 
@@ -80,14 +79,4 @@
     d_azimuth( azimuth ),
     d_radius( radius )
-{
-}
-
-/*!
-    Constructs a point using the values of the point specified.
-    \param other Other point
-*/
-inline QwtPointPolar::QwtPointPolar( const QwtPointPolar &other ):
-    d_azimuth( other.d_azimuth ),
-    d_radius( other.d_radius )
 {
 }
@@ -191,7 +180,7 @@
 inline QPointF qwtFastDegree2Pos( const QPointF &pole,
     double radius, double angle )
-{   
+{
     return qwtFastPolar2Pos( pole, radius, angle / 180.0 * M_PI );
-} 
+}
 
 inline QwtPointPolar qwtFastPos2Polar( const QPointF &pos )
@@ -201,3 +190,3 @@
 }
 
-#endif 
+#endif
Index: trunk/BNC/qwt/qwt_raster_data.cpp
===================================================================
--- trunk/BNC/qwt/qwt_raster_data.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_raster_data.cpp	(revision 9383)
@@ -217,11 +217,11 @@
    \brief Pixel hint
 
-   pixelHint() returns the geometry of a pixel, that can be used 
+   pixelHint() returns the geometry of a pixel, that can be used
    to calculate the resolution and alignment of the plot item, that is
-   representing the data. 
-   
-   Width and height of the hint need to be the horizontal  
-   and vertical distances between 2 neighbored points. 
-   The center of the hint has to be the position of any point 
+   representing the data.
+
+   Width and height of the hint need to be the horizontal
+   and vertical distances between 2 neighbored points.
+   The center of the hint has to be the position of any point
    ( it doesn't matter which one ).
 
@@ -230,5 +230,5 @@
    Limiting the resolution of the image might significantly improve
    the performance and heavily reduce the amount of memory when rendering
-   a QImage from the raster data. 
+   a QImage from the raster data.
 
    The default implementation returns an empty rectangle recommending
@@ -238,10 +238,10 @@
                depend on the requested area.
 
-   \return Bounding rectangle of a pixel 
+   \return Bounding rectangle of a pixel
 */
 QRectF QwtRasterData::pixelHint( const QRectF &area ) const
 {
     Q_UNUSED( area );
-    return QRectF(); 
+    return QRectF();
 }
 
@@ -281,4 +281,9 @@
     QwtRasterData *that = const_cast<QwtRasterData *>( this );
     that->initRaster( rect, raster );
+
+#if __GNUC__ >= 9
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-copy"
+#endif
 
     for ( int y = 0; y < raster.height() - 1; y++ )
@@ -399,4 +404,8 @@
     }
 
+#if __GNUC__ >= 9
+#pragma GCC diagnostic pop
+#endif
+
     that->discardRaster();
 
Index: trunk/BNC/qwt/qwt_round_scale_draw.cpp
===================================================================
--- trunk/BNC/qwt/qwt_round_scale_draw.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_round_scale_draw.cpp	(revision 9383)
@@ -185,5 +185,5 @@
    \param painter Painter
    \param value Value of the tick
-   \param len Lenght of the tick
+   \param len Length of the tick
 
    \sa drawBackbone(), drawLabel()
Index: trunk/BNC/qwt/qwt_round_scale_draw.h
===================================================================
--- trunk/BNC/qwt/qwt_round_scale_draw.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_round_scale_draw.h	(revision 9383)
@@ -46,5 +46,5 @@
 
 protected:
-    virtual void drawTick( QPainter *, double val, double len ) const;
+    virtual void drawTick( QPainter *, double value, double len ) const;
     virtual void drawBackbone( QPainter * ) const;
     virtual void drawLabel( QPainter *, double val ) const;
Index: trunk/BNC/qwt/qwt_sampling_thread.h
===================================================================
--- trunk/BNC/qwt/qwt_sampling_thread.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_sampling_thread.h	(revision 9383)
@@ -1,2 +1,11 @@
+/* -*- mode: C++ ; c-file-style: "stroustrup" -*- *****************************
+ * Qwt Widget Library
+ * Copyright (C) 1997   Josef Wilgen
+ * Copyright (C) 2002   Uwe Rathmann
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the Qwt License, Version 1.0
+ *****************************************************************************/
+
 #ifndef _QWT_SAMPLING_THREAD_H_
 #define _QWT_SAMPLING_THREAD_H_
Index: trunk/BNC/qwt/qwt_scale_draw.h
===================================================================
--- trunk/BNC/qwt/qwt_scale_draw.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_scale_draw.h	(revision 9383)
@@ -36,17 +36,17 @@
         \sa setAlignment(), alignment()
      */
-    enum Alignment 
-    { 
+    enum Alignment
+    {
         //! The scale is below
-        BottomScale, 
+        BottomScale,
 
         //! The scale is above
-        TopScale, 
+        TopScale,
 
         //! The scale is left
-        LeftScale, 
+        LeftScale,
 
         //! The scale is right
-        RightScale 
+        RightScale
     };
 
@@ -81,17 +81,17 @@
     int maxLabelWidth( const QFont & ) const;
 
-    QPointF labelPosition( double val ) const;
+    QPointF labelPosition( double value ) const;
 
-    QRectF labelRect( const QFont &, double val ) const;
-    QSizeF labelSize( const QFont &, double val ) const;
+    QRectF labelRect( const QFont &, double value ) const;
+    QSizeF labelSize( const QFont &, double value ) const;
 
-    QRect boundingLabelRect( const QFont &, double val ) const;
+    QRect boundingLabelRect( const QFont &, double value ) const;
 
 protected:
     QTransform labelTransformation( const QPointF &, const QSizeF & ) const;
 
-    virtual void drawTick( QPainter *, double val, double len ) const;
+    virtual void drawTick( QPainter *, double value, double len ) const;
     virtual void drawBackbone( QPainter * ) const;
-    virtual void drawLabel( QPainter *, double val ) const;
+    virtual void drawLabel( QPainter *, double value ) const;
 
 private:
Index: trunk/BNC/qwt/qwt_scale_engine.cpp
===================================================================
--- trunk/BNC/qwt/qwt_scale_engine.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_scale_engine.cpp	(revision 9383)
@@ -32,5 +32,5 @@
 }
 
-static inline QwtInterval qwtPowInterval( double base, const QwtInterval &interval ) 
+static inline QwtInterval qwtPowInterval( double base, const QwtInterval &interval )
 {
     return QwtInterval( qPow( base, interval.minValue() ),
@@ -52,5 +52,5 @@
 static double qwtStepSize( double intervalSize, int maxSteps, uint base )
 {
-    const double minStep = 
+    const double minStep =
         QwtScaleArithmetic::divideInterval( intervalSize, maxSteps, base );
 
@@ -171,6 +171,6 @@
   \return Calculated step size
  */
-double QwtScaleArithmetic::divideInterval( 
-    double intervalSize, int numSteps, uint base ) 
+double QwtScaleArithmetic::divideInterval(
+    double intervalSize, int numSteps, uint base )
 {
     if ( numSteps <= 0 )
@@ -269,5 +269,5 @@
 
 /*!
-   Create and return a clone of the transformation 
+   Create and return a clone of the transformation
    of the engine. When the engine has no special transformation
    NULL is returned, indicating no transformation.
@@ -340,5 +340,5 @@
     double intervalSize, int numSteps ) const
 {
-    return QwtScaleArithmetic::divideInterval( 
+    return QwtScaleArithmetic::divideInterval(
         intervalSize, numSteps, d_data->base );
 }
@@ -468,5 +468,5 @@
 /*!
   \brief Specify a reference point
-  \param r new reference value
+  \param reference New reference value
 
   The reference point is needed if options IncludeReference or
@@ -475,7 +475,7 @@
   \sa Attribute
 */
-void QwtScaleEngine::setReference( double r )
-{
-    d_data->referenceValue = r;
+void QwtScaleEngine::setReference( double reference )
+{
+    d_data->referenceValue = reference;
 }
 
@@ -502,5 +502,5 @@
  */
 void QwtScaleEngine::setBase( uint base )
-{ 
+{
     d_data->base = qMax( base, 2U );
 }
@@ -559,5 +559,5 @@
         interval = buildInterval( interval.minValue() );
 
-    stepSize = QwtScaleArithmetic::divideInterval( 
+    stepSize = QwtScaleArithmetic::divideInterval(
         interval.width(), qMax( maxNumSteps, 1 ), base() );
 
@@ -607,5 +607,5 @@
             maxMajorSteps = 1;
 
-        stepSize = QwtScaleArithmetic::divideInterval( 
+        stepSize = QwtScaleArithmetic::divideInterval(
             interval.width(), maxMajorSteps, base() );
     }
@@ -757,5 +757,5 @@
     double x2 = interval.maxValue();
 
-    // when there is no rounding beside some effect, when 
+    // when there is no rounding beside some effect, when
     // calculating with doubles, we keep the original value
 
@@ -868,5 +868,5 @@
         interval = buildInterval( interval.minValue() );
 
-    stepSize = divideInterval( qwtLogInterval( logBase, interval ).width(), 
+    stepSize = divideInterval( qwtLogInterval( logBase, interval ).width(),
         qMax( maxNumSteps, 1 ) );
     if ( stepSize < 1.0 )
@@ -928,5 +928,5 @@
             maxMajorSteps = 1;
 
-        stepSize = divideInterval( 
+        stepSize = divideInterval(
             qwtLogInterval( logBase, interval ).width(), maxMajorSteps );
         if ( stepSize < 1.0 )
@@ -1033,6 +1033,6 @@
         if ( minStep == 0.0 )
             return;
-        
-        const int numSteps = qRound( stepSize / minStep ); 
+
+        const int numSteps = qRound( stepSize / minStep );
 
         int mediumTickIndex = -1;
@@ -1088,5 +1088,5 @@
 
         if ( numTicks < 1 )
-            return; 
+            return;
 
         int mediumTickIndex = -1;
Index: trunk/BNC/qwt/qwt_scale_engine.h
===================================================================
--- trunk/BNC/qwt/qwt_scale_engine.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_scale_engine.h	(revision 9383)
@@ -26,7 +26,7 @@
     static double floorEps( double value, double intervalSize );
 
-    static double divideEps( double interval, double steps );
-
-    static double divideInterval( double interval, 
+    static double divideEps( double intervalSize, double numSteps );
+
+    static double divideInterval( double intervalSize,
         int numSteps, uint base );
 };
@@ -40,5 +40,5 @@
   The layout of the scale can be varied with setAttribute().
 
-  Qwt offers implementations for logarithmic and linear scales. 
+  Qwt offers implementations for logarithmic and linear scales.
 */
 
@@ -46,5 +46,5 @@
 {
 public:
-    /*! 
+    /*!
        Layout attributes
        \sa setAttribute(), testAttribute(), reference(),
@@ -65,5 +65,5 @@
         /*!
            The endpoints of the scale are supposed to be equal the
-           outmost included values plus the specified margins 
+           outmost included values plus the specified margins
            (see setMargins()).
            If this attribute is *not* set, the endpoints of the scale will
@@ -91,5 +91,5 @@
     Attributes attributes() const;
 
-    void setReference( double reference );
+    void setReference( double );
     double reference() const;
 
@@ -129,10 +129,10 @@
 
 protected:
-    bool contains( const QwtInterval &, double val ) const;
+    bool contains( const QwtInterval &, double value ) const;
     QList<double> strip( const QList<double>&, const QwtInterval & ) const;
 
-    double divideInterval( double interval, int numSteps ) const;
-
-    QwtInterval buildInterval( double v ) const;
+    double divideInterval( double intervalSize, int numSteps ) const;
+
+    QwtInterval buildInterval( double value ) const;
 
 private:
@@ -154,10 +154,10 @@
     virtual ~QwtLinearScaleEngine();
 
-    virtual void autoScale( int maxSteps,
+    virtual void autoScale( int maxNumSteps,
         double &x1, double &x2, double &stepSize ) const;
 
     virtual QwtScaleDiv divideScale( double x1, double x2,
-        int numMajorSteps, int numMinorSteps,
-                                     double stepSize = 0.0 ) const;
+        int maxMajorSteps, int maxMinorSteps,
+        double stepSize = 0.0 ) const;
 
 
@@ -166,5 +166,5 @@
 
     void buildTicks(
-        const QwtInterval &, double stepSize, int maxMinSteps,
+        const QwtInterval &, double stepSize, int maxMinorSteps,
         QList<double> ticks[QwtScaleDiv::NTickTypes] ) const;
 
@@ -194,9 +194,9 @@
     virtual ~QwtLogScaleEngine();
 
-    virtual void autoScale( int maxSteps,
+    virtual void autoScale( int maxNumSteps,
         double &x1, double &x2, double &stepSize ) const;
 
     virtual QwtScaleDiv divideScale( double x1, double x2,
-        int numMajorSteps, int numMinorSteps,
+        int maxMajorSteps, int maxMinorSteps,
         double stepSize = 0.0 ) const;
 
@@ -205,5 +205,5 @@
 
     void buildTicks(
-        const QwtInterval &, double stepSize, int maxMinSteps,
+        const QwtInterval &, double stepSize, int maxMinorSteps,
         QList<double> ticks[QwtScaleDiv::NTickTypes] ) const;
 
Index: trunk/BNC/qwt/qwt_scale_widget.cpp
===================================================================
--- trunk/BNC/qwt/qwt_scale_widget.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_scale_widget.cpp	(revision 9383)
@@ -21,4 +21,5 @@
 #include <qstyle.h>
 #include <qstyleoption.h>
+#include <qapplication.h>
 
 class QwtScaleWidget::PrivateData
@@ -146,4 +147,6 @@
         else
             d_data->layoutFlags &= ~flag;
+
+        update();
     }
 }
@@ -574,4 +577,21 @@
     {
         updateGeometry();
+
+#if 1
+        /*
+            for some reason updateGeometry does not send a LayoutRequest event
+            when the parent is not visible and has no layout
+         */
+
+        if ( QWidget* w = parentWidget() )
+        {
+            if ( !w->isVisible() && w->layout() == NULL )
+            {
+                if ( w->testAttribute( Qt::WA_WState_Polished ) )
+                    QApplication::postEvent( w, new QEvent( QEvent::LayoutRequest ) );
+            }
+        }
+#endif
+
         update();
     }
@@ -768,7 +788,7 @@
   is returned.
 
-  \param start Return parameter for the border width at 
+  \param start Return parameter for the border width at
                the beginning of the scale
-  \param end Return parameter for the border width at the 
+  \param end Return parameter for the border width at the
              end of the scale
 
@@ -808,7 +828,7 @@
   the widget borders.
 
-  \param start Return parameter for the border width at 
+  \param start Return parameter for the border width at
                the beginning of the scale
-  \param end Return parameter for the border width at the 
+  \param end Return parameter for the border width at the
              end of the scale
 
Index: trunk/BNC/qwt/qwt_scale_widget.h
===================================================================
--- trunk/BNC/qwt/qwt_scale_widget.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_scale_widget.h	(revision 9383)
@@ -40,5 +40,5 @@
     {
         /*!
-          The title of vertical scales is painted from top to bottom. 
+          The title of vertical scales is painted from top to bottom.
           Otherwise it is painted from bottom to top.
          */
@@ -65,5 +65,5 @@
     bool testLayoutFlag( LayoutFlag ) const;
 
-    void setBorderDist( int start, int end );
+    void setBorderDist( int dist1, int dist2 );
     int startBorderDist() const;
     int endBorderDist() const;
@@ -77,8 +77,8 @@
     int margin() const;
 
-    void setSpacing( int td );
+    void setSpacing( int );
     int spacing() const;
 
-    void setScaleDiv( const QwtScaleDiv &sd );
+    void setScaleDiv( const QwtScaleDiv & );
     void setTransformation( QwtTransform * );
 
@@ -120,8 +120,8 @@
     virtual void resizeEvent( QResizeEvent * );
 
-    void draw( QPainter *p ) const;
+    void draw( QPainter * ) const;
 
     void scaleChange();
-    void layoutScale( bool update = true );
+    void layoutScale( bool update_geometry = true );
 
 private:
Index: trunk/BNC/qwt/qwt_series_data.cpp
===================================================================
--- trunk/BNC/qwt/qwt_series_data.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_series_data.cpp	(revision 9383)
@@ -34,4 +34,7 @@
 static inline QRectF qwtBoundingRect( const QwtSetSample &sample )
 {
+    if ( sample.set.empty() )
+        return QRectF( sample.value, 0.0, 0.0, -1.0 );
+
     double minY = sample.set[0];
     double maxY = sample.set[0];
@@ -41,12 +44,10 @@
         if ( sample.set[i] < minY )
             minY = sample.set[i];
+
         if ( sample.set[i] > maxY )
             maxY = sample.set[i];
     }
 
-    double minX = sample.value;
-    double maxX = sample.value;
-
-    return QRectF( minX, minY, maxX - minX, maxY - minY );
+    return QRectF( sample.value, minY, 0.0, maxY - minY );
 }
 
Index: trunk/BNC/qwt/qwt_series_data.h
===================================================================
--- trunk/BNC/qwt/qwt_series_data.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_series_data.h	(revision 9383)
@@ -26,7 +26,7 @@
    to implement an individual data access.
 
-   A subclass of QwtSeriesData<QPointF> must implement: 
-
-   - size()\n 
+   A subclass of QwtSeriesData<QPointF> must implement:
+
+   - size()\n
      Should return number of data points.
 
@@ -35,12 +35,12 @@
      as QPointF object.
 
-   - boundingRect()\n 
+   - boundingRect()\n
      Should return the bounding rectangle of the data series.
      It is used for autoscaling and might help certain algorithms for displaying
      the data. You can use qwtBoundingRect() for an implementation
-     but often it is possible to implement a more efficient algorithm 
+     but often it is possible to implement a more efficient algorithm
      depending on the characteristics of the series.
      The member d_boundingRect is intended for caching the calculated rectangle.
-    
+
 */
 template <typename T>
@@ -53,4 +53,6 @@
     //! Destructor
     virtual ~QwtSeriesData();
+
+#ifndef QWT_PYTHON_WRAPPER
 
     //! \return Number of samples
@@ -78,4 +80,11 @@
     virtual QRectF boundingRect() const = 0;
 
+#else
+    // Needed for generating the python bindings, but not for using them !
+    virtual size_t size() const { return 0; }
+    virtual T sample( size_t i ) const { return T(); }
+    virtual QRectF boundingRect() const { return d_boundingRect; }
+#endif
+
     /*!
        Set a the "rect of interest"
@@ -86,5 +95,5 @@
 
        The default implementation does nothing.
-   
+
        \param rect Rectangle of interest
     */
@@ -275,54 +284,51 @@
     The following example shows finds a point of curve from an x
     coordinate
-
-  \verbatim
-#include <qwt_series_data.h>
-#include <qwt_plot_curve.h>
-
-struct compareX
-{
-    inline bool operator()( const double x, const QPointF &pos ) const
-    {
-        return ( x < pos.x() );
-    }
-};
-
-QLineF curveLineAt( const QwtPlotCurve *curve, double x )
-{
-    int index = qwtUpperSampleIndex<QPointF>( 
-        *curve->data(), x, compareX() );
-            
-    if ( index == -1 && 
-        x == curve->sample( curve->dataSize() - 1 ).x() )
-    {   
-        // the last sample is excluded from qwtUpperSampleIndex
-        index = curve->dataSize() - 1;
-    }
-
-    QLineF line; // invalid
-    if ( index > 0 )
-    {
-        line.setP1( curve->sample( index - 1 ) );
-        line.setP2( curve->sample( index ) );
-    }
-
-    return line;
-}
-
-\endverbatim
-
-
-    \param series Series of samples
-    \param value Value
-    \param lessThan Compare operation
-
-    \note The samples must be sorted according to the order specified 
-          by the lessThan object
-
-of the range [begin, end) and returns the position of the one-past-the-last occurrence of value. If no such item is found, returns the position where the item should be inserted.
+    \code
+      #include <qwt_series_data.h>
+      #include <qwt_plot_curve.h>
+
+      struct compareX
+      {
+          inline bool operator()( const double x, const QPointF &pos ) const
+          {
+              return ( x < pos.x() );
+          }
+      };
+
+      QLineF curveLineAt( const QwtPlotCurve *curve, double x )
+      {
+          int index = qwtUpperSampleIndex<QPointF>(
+              *curve->data(), x, compareX() );
+
+          if ( index == -1 &&
+              x == curve->sample( curve->dataSize() - 1 ).x() )
+          {
+              // the last sample is excluded from qwtUpperSampleIndex
+              index = curve->dataSize() - 1;
+          }
+
+          QLineF line; // invalid
+          if ( index > 0 )
+          {
+              line.setP1( curve->sample( index - 1 ) );
+              line.setP2( curve->sample( index ) );
+          }
+
+          return line;
+      }
+
+    \endcode
+  \endpar
+
+  \param series Series of samples
+  \param value Value
+  \param lessThan Compare operation
+
+  \note The samples must be sorted according to the order specified
+        by the lessThan object
  */
 template <typename T, typename LessThan>
 inline int qwtUpperSampleIndex( const QwtSeriesData<T> &series,
-    double value, LessThan lessThan  ) 
+    double value, LessThan lessThan  )
 {
     const int indexMax = series.size() - 1;
Index: trunk/BNC/qwt/qwt_series_store.h
===================================================================
--- trunk/BNC/qwt/qwt_series_store.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_series_store.h	(revision 9383)
@@ -28,4 +28,5 @@
     virtual ~QwtAbstractSeriesStore() {}
 
+#ifndef QWT_PYTHON_WRAPPER
     //! dataChanged() indicates, that the series has been changed.
     virtual void dataChanged() = 0;
@@ -42,4 +43,11 @@
     //! \return Number of samples
     virtual size_t dataSize() const = 0;
+#else
+    // Needed for generating the python bindings, but not for using them !
+    virtual void dataChanged() {}
+    virtual void setRectOfInterest( const QRectF & ) {}
+    virtual QRectF dataRect() const { return  QRectF( 0.0, 0.0, -1.0, -1.0 ); }
+    virtual size_t dataSize() const { return 0; }
+#endif
 };
 
